/*
 * @Description:
 * @Version: 1.0
 * @Autor: zhuyijun
 * @Date: 2021-11-10 13:09:52
 * @LastEditTime: 2021-11-10 16:39:11
 */
/*
    题目: 给定一棵树的前序遍历 preorder 与中序遍历
    inorder。请构造二叉树并返回其根节点。

    Input: preorder = [3,9,20,15,7], inorder = [9,3,15,20,7]
    Output: [3,9,20,null,null,15,7]

    示例 2:
    Input: preorder = [-1], inorder = [-1]
    Output: [-1]

    提示:
    1 <= preorder.length <= 3000
    inorder.length == preorder.length
    -3000 <= preorder[i], inorder[i] <= 3000
    preorder 和 inorder 均无重复元素
    inorder 均出现在 preorder
    preorder 保证为二叉树的前序遍历序列
    inorder 保证为二叉树的中序遍历序列
 */

// 前序:root -> left -> right  中序 left->root->right   后序: right->left->root
#include <bits/stdc++.h>
using namespace std;
struct TreeNode {
  int val;
  TreeNode *left;
  TreeNode *right;
  TreeNode() : val(0), left(nullptr), right(nullptr) {}
  TreeNode(int x) : val(x), left(nullptr), right(nullptr) {}
  TreeNode(int x, TreeNode *left, TreeNode *right)
      : val(x), left(left), right(right) {}
};

TreeNode *pre_order(vector<int> &pre, int leftpre, int rightpre,
                    vector<int> &in, int leftin, int rightin) {
  if (leftpre > rightpre || leftin > rightin) return nullptr;

  TreeNode *root = new TreeNode(pre[leftpre]);

  int rootin = leftin;

  while (rootin <= rightin && in[rootin] != pre[leftpre]) rootin++;
  int left = rootin - leftin;

  root->left =
      pre_order(pre, leftpre + 1, leftpre + left, in, leftin, rootin - 1);

  root->right =
      pre_order(pre, leftpre + left + 1, rightpre, in, rootin + 1, rightin);
  return root;
}

TreeNode *buildTree(vector<int> &preorder, vector<int> &inorder) {
  return pre_order(preorder, 0, preorder.size() - 1, inorder, 0,
                   inorder.size() - 1);
}

void printTree(TreeNode *root, vector<int> *res) {
  if (root == nullptr) {
    return;
  }
  res->push_back(root->val);
  printTree(root->left, res);
  printTree(root->right, res);
}
int main() {
  vector<int> pre;
  pre.push_back(3);
  pre.push_back(9);
  pre.push_back(20);
  pre.push_back(15);
  pre.push_back(7);

  vector<int> in;
  in.push_back(9);
  in.push_back(3);
  in.push_back(15);
  in.push_back(20);
  in.push_back(7);
  TreeNode *root = buildTree(pre, in);
  vector<int> res;
  printTree(root, &res);
  for (int i = 0; i < res.size(); i++) {
    std::cout << res[i] << " ";
  }
  return 0;
}