/*
 * @Description:
 * @Version: 1.0
 * @Autor: zhuyijun
 * @Date: 2021-11-10 20:51:48
 * @LastEditTime: 2021-11-10 21:43:10
 */
//恢复二叉搜索树
/*
给你二叉搜索树的根节点 root
，该树中的两个节点被错误地交换。请在不改变其结构的情况下，恢复这棵树。

进阶：使用 O(n)
空间复杂度的解法很容易实现。你能想出一个只使用常数空间的解决方案吗？

输入：root = [1,3,null,null,2]
输出：[3,1,null,null,2]
解释：3 不能是 1 左孩子，因为 3 > 1 。交换 1 和 3 使二叉搜索树有效。

*/

/*
 * BST 的中序遍历是一个从小到大的数组,两个节点错乱会 不满足 S[a] < S[a+1]，所以
 * 第一个错乱点  S[a] > S[a+1] 中的S[a]  ,第二个错乱点  S[a] > S[a+1]中的 S[a+1]
 */
#include <bits/stdc++.h>
using namespace std;
struct TreeNode {
  int val;
  TreeNode *left;
  TreeNode *right;
  TreeNode() : val(0), left(nullptr), right(nullptr) {}
  TreeNode(int x) : val(x), left(nullptr), right(nullptr) {}
  TreeNode(int x, TreeNode *left, TreeNode *right)
      : val(x), left(left), right(right) {}
};
TreeNode *t1, *t2, *pre;
void recoverTree(TreeNode *root) {
  inorder(root);
  int temp = t1->val;
  t1->val = t2->val;
  t2->val = temp;
}
void inorder(TreeNode *root) {
  if (root == nullptr) return;
  inorder(root->left);
  if (pre != nullptr && pre->val > root->val) {
    if (t1 == nullptr) t1 = pre;
    t2 = root;
  }
  pre = root;
  inorder(root->right);
}